#include "capture.h"

MODULE = POSIX::Run::Capture		PACKAGE = POSIX::Run::Capture PREFIX = capture_
PROTOTYPES: ENABLE

POSIX::Run::Capture
capture_new(package, argv)
	char *package;
	AV *argv;
  CODE:
	RETVAL = capture_new(argv);
        if (!RETVAL)
		croak("Out of memory!");
  OUTPUT:
        RETVAL

void
capture_DESTROY(rc)
	POSIX::Run::Capture rc;

int
capture_run(rc)
	POSIX::Run::Capture rc;
  CODE:
	if (!rc->rc_argv)
		croak("no command line given");
	RETVAL = runcap(rc, 0);
  OUTPUT:
        RETVAL

int
capture_status(rc)
	POSIX::Run::Capture rc;
  CODE:
	RETVAL = rc->rc_status;
  OUTPUT:
        RETVAL

int
capture_errno(rc)
	POSIX::Run::Capture rc;
  CODE:
	RETVAL = rc->rc_errno;
  OUTPUT:
        RETVAL

size_t
capture_nlines(rc, n)
	POSIX::Run::Capture rc;
	int n;
  CODE:
	if (n != RUNCAP_STDOUT && n != RUNCAP_STDERR) {
		croak("invalid stream number: %d", n);
	}
        RETVAL = rc->rc_cap[n].sc_nlines;
  OUTPUT:
        RETVAL

size_t
capture_length(rc, n)
	POSIX::Run::Capture rc;
	int n;
  CODE:
	if (n != RUNCAP_STDOUT && n != RUNCAP_STDERR) {
		croak("invalid stream number: %d", n);
	}
        RETVAL = rc->rc_cap[n].sc_leng;
  OUTPUT:
        RETVAL
	
char *
capture_next_line(rc, n)
	POSIX::Run::Capture rc;
	int n;
